--
-- Procedura di creazione vista FATTELEM di VISTE2
--
-- Autore: R.FERRARI
-- Data creazione:	10/07/2017
-- Variato da: <sviluppatore>
-- Data variazione: gg/mm/aaaa
-- Note:			<note di variazione>
--

print '<< Inizio script di creazione vista fattelem -' + CAST(getdate() AS varchar(30)) + ' >>'

if exists (select * from dbo.sysobjects  where xtype = 'V' and name='fattelem')
drop view fattelem
go

create view fattelem as 
select tmc_ese,tmc_prot,tmc_num, isnull(iva_riga, 10) iva_riga ,tmc_datreg,tmc_data,tmc_tm,tmc_cd,tmc_opcol,fat_totiva,
        fat_totfat,fat_datdoc,fat_datreg,fat_ndoc,fat_pc,fat_clfo,fat_totval,fat_divisa,
        fat_cambio,fat_giva,fat_viva,fat_segno, fat_f_sosp, fat_dtric, fat_dttras, fat_dtrif, fat_jvc1, fat_jvc2, fat_jvc3,
        fat_jvc4,fat_jf1, fat_jf2, fat_jn1, fat_jn2, fat_jdt1, fat_jdt2, iva_impon, iva_imposta, iva_cod, 
        (select t007_aliq from t_007 where t007_cod = iva_cod) iva_aliq, cnl_fdt, cnl_ff, cnl_fc, cnl_idcar,
		(select tp_dato from tab_pers where tp_tab = 'CLIFOR' and tp_cod = cf_cod and tp_voce = '$CF_DFATT') cf_dfatt
 from tesmov (nolock) left outer join tab_pers tb_t043 (nolock) on 
                                     (tb_t043.tp_tab = 'T_043' and tb_t043.tp_voce = '$T043_DFATT' and tb_t043.tp_cod = tmc_tm),
      clifor (nolock) left outer join tab_pers tb_clifor (nolock) on 
                                     (tb_clifor.tp_tab= 'CLIFOR' and tb_clifor.tp_voce = '$CF_DFATT' and tb_clifor.tp_cod = cf_cod), 
       ( select * from (select * from fattura (nolock) 
                        left outer join contrlink (nolock) on (cnl_ese = fat_ese and cnl_prot =fat_prot and cnl_num = fat_num)) fc
		left outer join moviva (nolock) on 
        (isnull(substring(pkfiller,1,4),fc.fat_ese)=iva_ese and isnull(substring(pkfiller,5,4),fc.fat_prot)=iva_prot
		and isnull(substring(pkfiller,9,8),fc.fat_num)=iva_num)) f left outer join tab_pers tb_t007 (nolock) on 
        (tb_t007.tp_tab = 'T_007' and tb_t007.tp_voce = '$T007_DFATT' and tb_t007.tp_cod = iva_cod)
 where (tb_t043.tp_dato != 'E' or tb_t043.tp_dato is null or (cnl_ff='S' and cnl_fdt in ('SI','CO')))
   and (tb_clifor.tp_dato!='E' or tb_clifor.tp_dato is null or (cnl_ff='S' and cnl_fdt in ('SI','CO'))) 
   and (tb_t007.tp_dato!='E' or tb_t007.tp_dato is null or (cnl_ff='S' and cnl_fdt in ('SI','CO'))) 
   and tmc_ese = fat_ese 
   and tmc_prot = fat_prot 
   and tmc_num  = fat_num 
   and tmc_tr = 'F' 
   and fat_clfo=cf_cod
union
  select tmc_ese,tmc_prot,tmc_num,mov_riga iva_riga ,tmc_datreg,tmc_data,tmc_tm,tmc_cd,tmc_opcol,0 fat_totiva,
        mov_importo fat_totfat,tmc_data fat_datdoc,tmc_datreg fat_datreg, cast (tmc_num as char(16)) fat_ndoc,mov_pc fat_pc, 
        mov_conto fat_clfo,mov_impval fat_totval,mov_divisa fat_divisa, mov_cambio fat_cambio,cast(null as char(2)) fat_giva, 
        (case t043_var when 'NO' then 'N' else 'S' end ) fat_viva, cast((case mov_segno when 'D' then 'A' else 'D' end) as char(1)) fat_segno, 
        'N' fat_f_sosp, cast(null as datetime) fat_dtric,cast(null as datetime) fat_dttras, cast(null as datetime) fat_dtrif, 
		cast(null as VARCHAR(40)) fat_jvc1, cast(null as VARCHAR(40)) fat_jvc2,cast(null as VARCHAR(256)) fat_jvc3,
		cast(null as VARCHAR(256)) fat_jvc4,cast(null as float) fat_jf1, cast(null as float) fat_jf2,cast(null as numeric(9,0)) fat_jn1,
		cast(null as numeric(9,0)) fat_jn2,cast(null as datetime) fat_jdt1, cast( null as datetime) fat_jdt2, 
		cast(null as float) iva_impon, cast(null as float) iva_imposta,
        cast(null as char(4)) iva_cod, cast(null as float) iva_aliq, cnl_fdt, cnl_ff, cnl_fc, cnl_idcar,
		(select tp_dato from tab_pers where tp_tab = 'CLIFOR' and tp_cod = cf_cod and tp_voce = '$CF_DFATT') cf_dfatt
 from contrlink (nolock) right outer join temo (nolock) on (cnl_ese = tmc_ese and cnl_prot = tmc_prot and cnl_num = tmc_num) 
      left outer join tab_pers tb_t043 (nolock) on (tb_t043.tp_tab = 'T_043' and tb_t043.tp_voce = '$T043_DFATT' and tb_t043.tp_cod = tmc_tm), t_043 (nolock),
      clifor (nolock) left outer join tab_pers tb_clifor (nolock) on (tb_clifor.tp_tab= 'CLIFOR' and tb_clifor.tp_voce = '$CF_DFATT' and tb_clifor.tp_cod = cf_cod)
 where (tb_t043.tp_dato = 'I' or (cnl_ff='S' and cnl_fdt = 'SI'))
   and (tb_clifor.tp_dato!='E' or tb_clifor.tp_dato is null or (cnl_ff='S' and cnl_fdt ='SI')) 
   and tmc_tr = 'F' 
   and mov_conto = cf_cod
   and tmc_tm = t043_cod
   and (t043_swf = 'NO' or t043_swf is null)
  
go

print '<< Fine script di creazione vista fattelem -' + CAST(getdate() AS varchar(30)) + ' >>'
