--
-- Procedura di creazione vista FATTELEM di VISTE2
--
-- Autore: R.FERRARI
-- Data creazione:	10/07/2017
-- Variato da: <sviluppatore>
-- Data variazione: gg/mm/aaaa
-- Note:			<note di variazione>
--
set ver off
set pages 0
set feed off
set trimspool on
set head off
SET sqlprompt " "
set termout off

CREATE OR REPLACE 
PROCEDURE pk_crea_fattelem
IS
   tab				VARCHAR2(30);
   from1			VARCHAR2(15);
   from2			VARCHAR2(15);
   fromtot  	VARCHAR2(160);
   data1      VARCHAR2(20);
   tSql				VARCHAR2(4000);
   testtab		NUMBER := 0;

BEGIN
	tab := 'FATTELEM';
	from1 := 'FATTURA';
	from2 := 'CONTRLINK';
	fromtot := from1||','||from2;

	SELECT TO_CHAR (sysdate, 'dd-mm-yyyy hh24:mi:ss')
     INTO data1
     FROM dual;

	DBMS_OUTPUT.put_line ('********************');
	DBMS_OUTPUT.put_line ('** ' || data1 || '');
	DBMS_OUTPUT.put_line ('** Inizio creazione vista ' || tab || ' su utente ' ||user|| '');
	DBMS_OUTPUT.put_line ('********************');

	-- Verifico se tutte le tabelle contenute nella clausola 'from' della vista esistono
	SELECT COUNT(*)
     INTO testtab
     FROM user_objects
    WHERE
		EXISTS (SELECT object_name FROM user_objects WHERE object_name = from1)
	AND EXISTS (SELECT object_name FROM user_objects WHERE object_name = from2);

	IF testtab > 0 THEN
		BEGIN

-- Inserire, tra i '' dell'istruzione seguente, l'intero script di creazione della vista
tSql := 'create or replace view fattelem as select tmc_ese,tmc_prot,tmc_num,nvl(iva_riga, 10) iva_riga ,tmc_datreg,tmc_data,tmc_tm,tmc_cd,tmc_opcol,fat_totiva,
        fat_totfat,fat_datdoc,fat_datreg,fat_ndoc,fat_pc,fat_clfo,fat_totval,fat_divisa,
        fat_cambio,fat_giva,fat_viva,fat_segno, fat_f_sosp, fat_dtric, fat_dttras, fat_dtrif, fat_jvc1, fat_jvc2, fat_jvc3,
        fat_jvc4,fat_jf1, fat_jf2, fat_jn1, fat_jn2, fat_jdt1, fat_jdt2, iva_impon, iva_imposta, iva_cod, 
        (select t007_aliq from t_007 where t007_cod = iva_cod) iva_aliq, cnl_fdt, cnl_ff, cnl_fc, cnl_idcar,
		(select tp_dato from tab_pers where tp_tab = ''CLIFOR'' and tp_cod = cf_cod and tp_voce = ''$CF_DFATT'') cf_dfatt
 from tesmov,clifor,tab_pers tb_t043, tab_pers tb_t007, tab_pers tb_clifor, 
       ( select * from (select * from fattura left outer join contrlink on (cnl_ese = fat_ese and cnl_prot =fat_prot and cnl_num = fat_num)) , moviva
 where nvl(substr(pkfiller,1,4),fat_ese)=iva_ese (+)
   and nvl(substr(pkfiller,5,4),fat_prot)=iva_prot (+)
   and nvl(substr(pkfiller,9,8),fat_num)=iva_num (+))
 where tb_t043.tp_tab (+) = ''T_043''
   and tb_t043.tp_voce (+) = ''$T043_DFATT''
   and tb_t043.tp_cod (+) = tmc_tm
   and (tb_t043.tp_dato != ''E'' or tb_t043.tp_dato is null or (cnl_ff=''S'' and cnl_fdt in (''SI'',''CO'')))
   and tb_clifor.tp_tab (+) = ''CLIFOR''
   and tb_clifor.tp_voce (+) = ''$CF_DFATT'' 
   and tb_clifor.tp_cod (+) = cf_cod 
   and (tb_clifor.tp_dato!=''E'' or tb_clifor.tp_dato is null or (cnl_ff=''S'' and cnl_fdt in (''SI'',''CO''))) 
   and tb_t007.tp_tab (+) = ''T_007''
   and tb_t007.tp_voce (+) = ''$T007_DFATT''
   and tb_t007.tp_cod (+) = iva_cod
   and (tb_t007.tp_dato!=''E'' or tb_t007.tp_dato is null or (cnl_ff=''S'' and cnl_fdt in (''SI'',''CO''))) 
   and tmc_ese = fat_ese 
   and tmc_prot = fat_prot 
   and tmc_num  = fat_num 
   and tmc_tr = ''F'' 
   and fat_clfo=cf_cod
union
  select tmc_ese,tmc_prot,tmc_num,mov_riga iva_riga ,tmc_datreg,tmc_data,tmc_tm,tmc_cd,tmc_opcol,0 fat_totiva,
        mov_importo fat_totfat,tmc_data fat_datdoc,tmc_datreg fat_datreg, cast (tmc_num as char(16)) fat_ndoc,mov_pc fat_pc, 
        mov_conto fat_clfo,mov_impval fat_totval,mov_divisa fat_divisa, mov_cambio fat_cambio,cast('''' as char(2)) fat_giva, 
        (case t043_var when ''NO'' then ''N'' else ''S'' end ) fat_viva, cast(decode(mov_segno,''D'',''A'',''D'') as char(1)) fat_segno, 
        ''N'' fat_f_sosp,cast( '''' as date) fat_dtric,cast( '''' as date) fat_dttras, cast('''' as date) fat_dtrif, cast('''' as VARCHAR2(40)) fat_jvc1,
        cast('''' as VARCHAR2(40)) fat_jvc2,cast('''' as VARCHAR2(256)) fat_jvc3,cast('''' as VARCHAR2(256)) fat_jvc4,cast('''' as number) fat_jf1,
        cast('''' as number) fat_jf2,cast('''' as number(8,0)) fat_jn1,cast('''' as number(8,0)) fat_jn2,cast('''' as date) fat_jdt1,
        cast( '''' as date) fat_jdt2, cast('''' as number) iva_impon,cast('''' as number) iva_imposta,
        cast('''' as char(4)) iva_cod, cast('''' as number) iva_aliq, cnl_fdt, cnl_ff, cnl_fc, cnl_idcar,
 		(select tp_dato from tab_pers where tp_tab = ''CLIFOR'' and tp_cod = cf_cod and tp_voce = ''$CF_DFATT'') cf_dfatt
from temo,clifor,tab_pers tb_t043, tab_pers tb_clifor, contrlink, t_043
 where tb_t043.tp_tab (+) = ''T_043''
   and tb_t043.tp_voce (+) = ''$T043_DFATT''
   and tb_t043.tp_cod (+) = tmc_tm
   and (tb_t043.tp_dato = ''I'' or (cnl_ff=''S'' and cnl_fdt = ''SI''))
   and tb_clifor.tp_tab (+) = ''CLIFOR''
   and tb_clifor.tp_voce (+) = ''$CF_DFATT'' 
   and tb_clifor.tp_cod (+) = cf_cod 
   and (tb_clifor.tp_dato!=''E'' or tb_clifor.tp_dato is null or (cnl_ff=''S'' and cnl_fdt =''SI'')) 
   and tmc_tr = ''F'' 
   and mov_conto = cf_cod
   and tmc_ese = cnl_ese (+)
   and tmc_prot = cnl_prot (+)
   and tmc_num  = cnl_num (+)
   and tmc_tm = t043_cod
   and (t043_swf = ''NO'' or t043_swf is null)';

			BEGIN
				EXECUTE IMMEDIATE tSql;
			EXCEPTION WHEN OTHERS THEN
				RAISE_APPLICATION_ERROR (-20001,sqlerrm||' - Errore in creazione vista FATTELEM');
			END;
  END;

	ELSE
		DBMS_OUTPUT.put_line ('Nello schema ' ||user|| ' manca almeno una delle seguenti tabelle: ' ||fromtot);
		DBMS_OUTPUT.put_line ('Viste FATTELEM non creata!');
	END IF;

	SELECT TO_CHAR (sysdate, 'dd-mm-yyyy hh24:mi:ss')
     INTO data1
     FROM dual;

	DBMS_OUTPUT.put_line ('********************');
	DBMS_OUTPUT.put_line ('** Fine creazione vista FATTELEM');
	DBMS_OUTPUT.put_line ('** ' || data1 || '');
	DBMS_OUTPUT.put_line ('********************');
END pk_crea_fattelem;
/

SET SERVEROUTPUT ON SIZE 1000000
spool vavis294.log

EXEC pk_crea_fattelem;
DROP PROCEDURE pk_crea_fattelem;

show err
spool OFF
quit
